/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pkg2013440041;

import aeat.AEATType;
import aeat.AEAType;
import java.io.File;
import java.io.StringReader;
import java.io.StringWriter;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.Clip;
import javax.swing.JOptionPane;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBElement;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.Unmarshaller;
import org.apache.camel.converter.IOConverter;

/**
 *
 * @author djj94
 */
public class Publisher {

    private Frame frame;
    // Frame 객체 생성
    public static final String AEAT_EXAM = "xml/AEAT-Example-20170920.xml";
    // AEAT_EXAM 경로 생성

    public Publisher() {
        MyButtonActionListener buttonActionListener = new MyButtonActionListener(this);
        frame = new Frame(buttonActionListener);
        // 버튼 리스너를 만들고 Frame 에 추가한다.

    }

    // 마샬링 코드 (그냥 외우는게 좋다)
    // 메소드 명 : aeatMarshalling()
    // 입력 : aeat 변수 루트객체 (AEATType) , 파일 경로(String)
    // 출력 : 없음
    // 부수효과 : 파일 경로에 aeat 값이 XML 로 마샬링 되어 저장된다.
    private void aeatMarshalling(AEATType aeat, String path) {
        try {
            JAXBContext jaxbContext = JAXBContext.newInstance(AEATType.class);
            Marshaller marshaller = jaxbContext.createMarshaller();
            marshaller.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, true);

            marshaller.marshal(aeat, new File(path));
        } catch (JAXBException e) {
            e.printStackTrace();
        }
    }

    // 언마샬링 코드 (그냥 외우는게 좋다)
    // 메소드 명 : aeatUnmarshalling()
    // 입력 : XML 파일 경로(String)
    // 출력 : XML 파일로 부터 읽어온 것을 언마샬링 하여 aeat 로 반환(AEATType)
    // 부수효과 : 없음
    private AEATType aeatUnmarshalling(String path) {
        AEATType aeat = null;
        try {
            File file = new File(path);

            JAXBContext jaxbContext = JAXBContext.newInstance(AEATType.class);
            Unmarshaller jaxbUnmarshaller = jaxbContext.createUnmarshaller();
            aeat = (AEATType) ((JAXBElement) jaxbUnmarshaller.unmarshal(file)).getValue();
        } catch (JAXBException e) {
            e.printStackTrace();
        }
        return aeat;
    }

    private AEATType aeatReceivedDataUnmarshalling(String input) {
        AEATType aeat = null;
        try {
            StringReader data = new StringReader(input);

            JAXBContext jaxbContext = JAXBContext.newInstance(AEATType.class);
            Unmarshaller jaxbUnmarshaller = jaxbContext.createUnmarshaller();
            aeat = (AEATType) ((JAXBElement) jaxbUnmarshaller.unmarshal(data)).getValue();
        } catch (JAXBException e) {
            e.printStackTrace();
        }
        return aeat;
    }

    // onClickedLoadButton()
    // 입력 : 없음
    // 출력 : 없음
    // 부수효과 : aeatUnmarshalling() 을 콜하여 aeat 로 초기화한다.
    // 그리고 frame.loadAeat() 메소드를 콜을 하여 aeat 변수를 넘긴다.
    public void onClickedLoadButton() {
        AEATType aeat = aeatUnmarshalling(AEAT_EXAM);
        frame.loadAeat(aeat);
    }

    // onClickedSaaveButton()
    // 입력 : 없음
    // 출력 : 없음
    // 부수효과 : frame.getAeat() 를 콜하여 aeat 변수에 저장한다.
    // 다음으로 aeatMarshalling 을 콜하여 aeat 변수와 경로(String) 을 전달한다.
    public void onClickedSaveButton() {
        //todo
        AEATType aeat = frame.getAeat();
        aeatMarshalling(aeat, "xml/output.xml");
    }

    static void PlaySound(File Sound) {

        try {
            Clip clip = AudioSystem.getClip();
            clip.open(AudioSystem.getAudioInputStream(Sound));
            clip.start();
            Thread.sleep(clip.getMicrosecondLength() / 1000);
        } catch (Exception e) {
        }
    }

    public static String aeatToXml(AEATType aeat) {
        String result = "";
        try {
            JAXBContext jaxbContext = JAXBContext.newInstance(AEATType.class);
            Marshaller marshaller = jaxbContext.createMarshaller();
            marshaller.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, true);
            //AEATType 객체를 "path" 경로에 파일로 저장
            StringWriter stringWriter = new StringWriter();
            marshaller.marshal(aeat, stringWriter);
            result = stringWriter.toString();
        } catch (JAXBException e) {
            e.printStackTrace();
        }
        return result;
    }

    public void onClickedSendButton() {
        String DESTIANTION_EXAM = frame.getConfigSendGroup(); // 데스티네이션 이름
        String MQ_ADDRESS = frame.getConfigSendServer(); // 메시지 브로커 주소
        AEATType aeat = frame.getAeat();
        String text = aeatToXml(aeat);

        try {
            ActiveMQProducer producer = new ActiveMQProducer(MQ_ADDRESS);
            producer.sendMessageTo(text, DESTIANTION_EXAM);
            Thread.sleep(100);
            producer.closeConnection();
        } catch (InterruptedException ex) {
            Logger.getLogger(this.getClass().getName()).log(Level.SEVERE, null, ex);
        }
    }

    public void onMessage(String input) {
        AEATType aeat = aeatReceivedDataUnmarshalling(input);
        frame.loadAeatReceived(aeat);

    }

    public void soundPlay() {
        File Clap = new File("receive.wav");
        PlaySound(Clap);
        JOptionPane.showMessageDialog(null, "AEAT 메시지 도착 \n받은 메시지에서 확인해 주세요.", "알림이 도착하였습니다.", JOptionPane.INFORMATION_MESSAGE);
    }

    public void onClickedReceiveButton() {
        String DESTIANTION_EXAM = frame.getConfigReceiveGroup(); // 데스티네이션 이름
        String MQ_ADDRESS = frame.getConfigReceiveServer(); // 메시지 브로커 주소

        try {
            ActiveMQConsumer consumer = new ActiveMQConsumer(MQ_ADDRESS, this);

            // Set consumer Destination
            // Send Message to Destination
            consumer.setConsumerDestination(DESTIANTION_EXAM);
            Thread.sleep(100);
        } catch (InterruptedException ex) {
            Logger.getLogger(this.getClass().getName()).log(Level.SEVERE, null, ex);
        }
    }

}
